//+------------------------------------------------------------------+
//|                                                  MonthlyPivot.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Black
#property indicator_color2 FireBrick
#property indicator_color3 FireBrick
#property indicator_color4 FireBrick
#property indicator_color5 FireBrick
#property indicator_color6 FireBrick
#property indicator_color7 FireBrick
#property indicator_color8 FireBrick
//---- input parameters

//---- buffers
double PBuffer[];
double R1Buffer[];
double M3Buffer[];
double R2Buffer[];
double M4Buffer[];
double R3Buffer[];
double M5Buffer[];
double S1Buffer[];
string Pivot="MonthlyPivotPoint",MRes1="M_R 1", MM3="M_M 3";
string MRes2="M_R 2", MM4="M_M 4", MRes3="M_R 3", MM5="M_M 5" ,MSup1="M_S 1";
int fontsize=10;
double P,R1,M3,R2,M4,R3,M5,S1;
double last_month_high, last_month_low, this_month_open, last_month_close;

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here

   ObjectDelete("MonthlyPivot");
   ObjectDelete("MRes1");
   ObjectDelete("MM3");
   ObjectDelete("MRes2");
   ObjectDelete("MM4");
   ObjectDelete("MRes3");
   ObjectDelete("MM5");  
   ObjectDelete("MSup1"); 

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;


//---- indicator line
   SetIndexStyle(0,DRAW_LINE,0,3,Magenta);
   SetIndexStyle(1,DRAW_LINE,0,3,FireBrick);
   SetIndexStyle(2,DRAW_LINE,0,3,FireBrick);
   SetIndexStyle(3,DRAW_LINE,0,3,FireBrick);
   SetIndexStyle(4,DRAW_LINE,0,3,FireBrick);
   SetIndexStyle(5,DRAW_LINE,0,3,FireBrick);
   SetIndexStyle(6,DRAW_LINE,0,3,FireBrick);
   SetIndexStyle(7,DRAW_LINE,0,3,FireBrick);
   SetIndexBuffer(0,PBuffer);
   SetIndexBuffer(1,R1Buffer);
   SetIndexBuffer(2,M3Buffer);
   SetIndexBuffer(3,R2Buffer);
   SetIndexBuffer(4,M4Buffer);
   SetIndexBuffer(5,R3Buffer);
   SetIndexBuffer(6,M5Buffer);
   SetIndexBuffer(7,S1Buffer);


//---- name for DataWindow and indicator subwindow label
   
   SetIndexLabel(0,"Monthly Pivot");
   SetIndexLabel(1,"Monthly R1");
   SetIndexLabel(2,"Monthly M3");
   SetIndexLabel(3,"Monthly R2");
   SetIndexLabel(4,"Monthly M4");
   SetIndexLabel(5,"Monthly R3");
   SetIndexLabel(6,"Monthly M5");
   SetIndexLabel(7,"Monthly S1");

//----
   SetIndexDrawBegin(0,1);
//----
 

//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()

  {
   int counted_bars=IndicatorCounted();

   int limit, i;
//---- indicator calculation
if (counted_bars==0)

   if(counted_bars<0) return(-1);

   limit=(Bars-counted_bars)-1;


for (i=limit; i>=0;i--)
{ 


   // 1st day of month
	if(TimeDay(Time[i])<=3 && TimeDay(Time[i+1])>=26)
	{
		last_month_close = Close[i+1];
		this_month_open = Open[i];

		// MonthlyPivot
		P = (last_month_high + last_month_low + last_month_close) / 3;

   R1 = (2*P)-last_month_low;
   S1 = (2*P)-last_month_high;
   R2 = P-S1+R1;
   M3 = (P+R1)/2;
   R3 = (2*P)+(last_month_high-(2*last_month_low));
   M4 = (R2+R1)/2;
   M5 = (R3+R2)/2; 
  
   last_month_low=Low[i]; last_month_high=High[i];

	ObjectMove("MonthlyPivot", 0, Time[i],P);
   ObjectMove("MRes1", 0, Time[i],R1);
   ObjectMove("MM3", 0, Time[i],M3);
   ObjectMove("MRes2", 0, Time[i],R2);
   ObjectMove("MM4", 0, Time[i],M4);
   ObjectMove("MRes3", 0, Time[i],R3);
   ObjectMove("MM5", 0, Time[i],M5);
   ObjectMove("MSup1", 0, Time[i],S1);

}   
    
    last_month_high = MathMax(last_month_high, High[i]);
 	 last_month_low = MathMin(last_month_low, Low[i]);   
    PBuffer[i]=P;
    R1Buffer[i]=R1;
    M3Buffer[i]=M3;
    R2Buffer[i]=R2;
    M4Buffer[i]=M4;
    R3Buffer[i]=R3;
    M5Buffer[i]=M5;
    S1Buffer[i]=S1;

}

//----
   return(0);
  }
//+------------------------------------------------------------------+